package com.zhibao.crm.ocr;

import com.jfinal.kit.PropKit;
import com.jfinal.plugin.redis.Redis;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.apache.http.Consts;
import org.apache.http.HttpEntity;
import org.apache.http.HttpVersion;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

public class OcrApi {

   public static Map URL_MAP = urlMap();
   public static Map NAME_MAP = nameMap();
   private static final String YB_TOKEN = "YB-TOKEN";
   public static final String IMG_URL = "imgUrl";
   public static final String TOKEN = "token";
   private static final String FILE = "file";
   private static final String ACCESS_KEY = "accessKey";
   private static final String ACCESS_SECRET = "accessSecret";
   private static final String ACCESS_KEY_VALUE = "APPID_7d004cy5574KM2Ry";
   private static final String ACCESS_SECRET_VALUE = "ad9854c50d7183aaf12fc553693a6393";
   private static final int SO_TIMEOUT = 30000;
   private static final int SO_TIMEOUT_DATA = 30000;
   static final String MEDICAL_CLASSIFY = "https://ai.ybinsure.com/s/api/ocr/genalClassify";


   public static Map urlMap() {
      HashMap map = new HashMap();
      map.put("1", "https://ai.ybinsure.com/s/api/ocr/medicalListing");
      map.put("2", "https://ai.ybinsure.com/s/api/ocr/medicalListing");
      map.put("3", "https://ai.ybinsure.com/s/api/ocr/medical");
      map.put("4", "https://ai.ybinsure.com/s/api/ocr/vatInvoice");
      map.put("5", "https://ai.ybinsure.com/s/api/ocr/medical");
      map.put("6", "https://ai.ybinsure.com/s/api/ocr/dischargeAbstract");
      map.put("7", "https://ai.ybinsure.com/s/api/ocr/medical");
      return map;
   }

   public static Map nameMap() {
      HashMap map = new HashMap();
      map.put("1", "结算单");
      map.put("2", "清单");
      map.put("3", "住院发票");
      map.put("4", "增值税发票");
      map.put("5", "门诊发票");
      map.put("6", "出院小结");
      map.put("7", "其它");
      return map;
   }

   public static void main(String[] args) throws Exception {
      getToken();
   }

   public static JSONObject OcrIdentifier(String image) throws Exception {
      HashMap map = new HashMap();
      map.put("imgUrl", PropKit.use("config/crm-config.txt").get("siteUrl") + image);
      map.put("token", getToken());
      String classifyResult = yuebaoPost("https://ai.ybinsure.com/s/api/ocr/genalClassify", map, (File)null);
      com.alibaba.fastjson.JSONObject classifyResultJson = com.alibaba.fastjson.JSONObject.parseObject(classifyResult);
      String flag = "";
      if(classifyResultJson.getInteger("code").intValue() == 0) {
         flag = classifyResultJson.getJSONObject("data").getString("flag");
      }

      String result = yuebaoPost((String)urlMap().get(flag), map, (File)null);
      JSONObject resultJson = new JSONObject(result);
      byte var8 = -1;
      switch(flag.hashCode()) {
      case 49:
         if(flag.equals("1")) {
            var8 = 0;
         }
         break;
      case 50:
         if(flag.equals("2")) {
            var8 = 1;
         }
         break;
      case 51:
         if(flag.equals("3")) {
            var8 = 2;
         }
         break;
      case 52:
         if(flag.equals("4")) {
            var8 = 3;
         }
         break;
      case 53:
         if(flag.equals("5")) {
            var8 = 4;
         }
         break;
      case 54:
         if(flag.equals("6")) {
            var8 = 5;
         }
         break;
      case 55:
         if(flag.equals("7")) {
            var8 = 6;
         }
      }

      switch(var8) {
      case 0:
         resultJson.put("type", "medical_statement");
         resultJson.put("invoice_type", "2");
         break;
      case 1:
         resultJson.put("type", "medical_detail");
         resultJson.put("invoice_type", "2");
         break;
      case 2:
         resultJson.put("type", "medical_invoice");
         resultJson.put("invoice_type", "2");
         break;
      case 3:
         resultJson.put("type", "medical_vat");
         break;
      case 4:
         resultJson.put("type", "medical_invoice");
         resultJson.put("invoice_type", "1");
         break;
      case 5:
         resultJson.put("type", "medical_summary");
         resultJson.put("invoice_type", "2");
         break;
      case 6:
         resultJson.put("type", "others");
      }

      return resultJson;
   }

   public static String getToken() throws Exception {
      String ybToken = (String)Redis.use().get("YB-TOKEN");
      if(ybToken == null) {
         HashMap mapParam = new HashMap();
         mapParam.put("accessKey", "APPID_7d004cy5574KM2Ry");
         mapParam.put("accessSecret", "ad9854c50d7183aaf12fc553693a6393");
         String url = "https://ai.ybinsure.com/s/api/getAccessToken";
         String result = yuebaoGet(url, mapParam);
         com.alibaba.fastjson.JSONObject resultJson = com.alibaba.fastjson.JSONObject.parseObject(result);
         if(resultJson != null && resultJson.getInteger("code").intValue() == 0) {
            com.alibaba.fastjson.JSONObject data = resultJson.getJSONObject("data");
            String accessToken = data.getString("access_token");
            Redis.use().setex("YB-TOKEN", data.getIntValue("expires_in"), accessToken);
            return ybToken;
         } else {
            throw new Exception("接口调用失败");
         }
      } else {
         return ybToken;
      }
   }

   public static String yuebaoPost(String url, Map param, File file) {
      String result = "";
      CloseableHttpClient httpClient = HttpClients.createDefault();
      RequestConfig requestConfig = RequestConfig.custom().setSocketTimeout(30000).setConnectTimeout(30000).setConnectionRequestTimeout(30000).build();
      HttpPost httpPost = new HttpPost(url);
      httpPost.setProtocolVersion(HttpVersion.HTTP_1_0);

      try {
         MultipartEntityBuilder e = MultipartEntityBuilder.create();
         if(file != null) {
            FileBody reqEntity = new FileBody(file);
            e.addPart("file", reqEntity);
         }

         if(param != null) {
            Iterator reqEntity1 = param.keySet().iterator();

            while(reqEntity1.hasNext()) {
               String response = (String)reqEntity1.next();
               e.addPart(response, new StringBody((String)param.get(response), ContentType.create("text/plain", Consts.UTF_8)));
            }
         }

         HttpEntity reqEntity2 = e.build();
         httpPost.setEntity(reqEntity2);
         httpPost.setConfig(requestConfig);
         CloseableHttpResponse response1 = httpClient.execute(httpPost);
         HttpEntity entity = response1.getEntity();
         result = EntityUtils.toString(entity);
         System.out.println("POST请求返回值：" + result);
      } catch (Exception var19) {
         var19.printStackTrace();
      } finally {
         try {
            httpClient.close();
         } catch (IOException var18) {
            var18.printStackTrace();
         }

      }

      return result;
   }

   public static String yuebaoGet(String url, Map param) {
      String result = "";
      CloseableHttpClient httpClient = HttpClients.createDefault();
      RequestConfig requestConfig = RequestConfig.custom().setSocketTimeout(30000).setConnectTimeout(30000).setConnectionRequestTimeout(30000).build();

      try {
         StringBuffer e = new StringBuffer();
         String params;
         if(param != null) {
            e.append("?");
            Iterator str = param.keySet().iterator();

            while(str.hasNext()) {
               params = (String)str.next();
               e.append(params);
               e.append("=");
               e.append((String)param.get(params));
               e.append("&");
            }
         }

         String str1 = e.toString();
         params = str1.substring(0, str1.length() - 1);
         HttpGet httpGet = new HttpGet(url + params);
         httpGet.setConfig(requestConfig);
         CloseableHttpResponse response = httpClient.execute(httpGet);
         HttpEntity entity = response.getEntity();
         result = EntityUtils.toString(entity);
         System.out.println("GET请求返回值：" + result);
      } catch (Exception var19) {
         var19.printStackTrace();
      } finally {
         try {
            httpClient.close();
         } catch (IOException var18) {
            var18.printStackTrace();
         }

      }

      return result;
   }

}
